您的位置:首页 > 其它

B - Pick The Sticks ----01背包

2017-04-17 19:35 225 查看
The story happened long long ago. One day, Cao Cao made a special order called "Chicken Rib" to his army. No one got his point and all became very panic. However, Cao Cao himself felt very proud of his interesting idea and enjoyed
it. 

Xiu Yang, one of the cleverest counselors of Cao Cao, understood the command Rather than keep it to himself, he told the point to the whole army. Cao Cao got very angry at his cleverness and would like to punish Xiu Yang. But how can you punish someone because
he's clever? By looking at the chicken rib, he finally got a new idea to punish Xiu Yang. 

He told Xiu Yang that as his reward of encrypting the special order, he could take as many gold sticks as possible from his desk. But he could only use one stick as the container. 

Formally, we can treat the container stick as an LL length
segment. And the gold sticks as segments too. There were many gold sticks with different length aiai and
value vivi.
Xiu Yang needed to put these gold segments onto the container segment. No gold segment was allowed to be overlapped. Luckily, Xiu Yang came up with a good idea. On the two sides of the container, he could make part of the gold sticks outside the container
as long as the center of the gravity of each gold stick was still within the container. This could help him get more valuable gold sticks. 

As a result, Xiu Yang took too many gold sticks which made Cao Cao much more angry. Cao Cao killed Xiu Yang before he made himself home. So no one knows how many gold sticks Xiu Yang made it in the container. 

Can you help solve the mystery by finding out what's the maximum value of the gold sticks Xiu Yang could have taken?

InputThe first line of the input gives the number of test cases, T(1≤T≤100)T(1≤T≤100). TT test
cases follow. Each test case start with two integers, N(1≤N≤1000)N(1≤N≤1000) and L(1≤L≤2000)L(1≤L≤2000),
represents the number of gold sticks and the length of the container stick. NN lines
follow. Each line consist of two integers, ai(1≤ai≤2000)ai(1≤ai≤2000)and vi(1≤vi≤109)vi(1≤vi≤109),
represents the length and the value of the ithith gold
stick.
OutputFor each test case, output one line containing Case #x: y, where xx is
the test case number (starting from 1) and yy is
the maximum value of the gold sticks Xiu Yang could have taken.
Sample Input
4

3 7
4 1
2 1
8 1

3 7
4 2
2 1
8 4

3 5
4 1
2 2
8 9

1 1
10 3


Sample Output
Case #1: 2
Case #2: 6
Case #3: 11
Case #4: 3


Hint
In the third case, assume the container is lay on x-axis from 0 to 5. Xiu Yang could put the second gold stick center at 0 and put the third gold stick center at 5,
so none of them will drop and he can get total 2+9=11 value.

In the fourth case, Xiu Yang could just put the only gold stick center on any position of [0,1], and he can get the value of 3.


题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5543

题目的意思是有一个n长度的桌子,我们往上面放金条,只要重心在上面就可以了,如果我们不允许超出长度,我们会惊讶的发现,就很像01背包,然后我们加一维表示两端放了多少东西。详细见代码吧,注意要交G++,c++竟然超时!

代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
#define LL long long
using namespace std;
int w[1001],v[1001];
LL dp[4004][3];
int main(){
int t,cas=0;;
scanf("%d",&t);
while(t--){
cas++;
LL sum=0;
int n,m;
scanf("%d%d",&n,&m);
m<<=1;
memset(dp,0,sizeof(dp));
for(int i=1;i<=n;i++){
scanf("%d%d",&w[i],&v[i]);
w[i]*=2;
sum=max((LL)v[i],sum);
for(int j=m;j>=w[i]/2;j--){
for(int k=0;k<=2;k++){
if(k>=1){
dp[j][k]=max(dp[j-w[i]/2][k-1]+v[i],dp[j][k]);
}

if(j>=w[i]){
dp[j][k]=max(dp[j-w[i]][k]+v[i],dp[j][k]);
}
sum=max(sum,dp[j][k]);
}
}
}
printf("Case #%d: %lld\n",cas,sum);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: